#!/usr/bin/python

import os
import stat
import sys

time_dict = dict()

def save_time_to_dict(file):
    time_dict[file] = os.stat(file)
    
def save_time():
    save_time_to_dict("/etc/exim4/conf.d/main/90_exim4-config_log_selector")
    save_time_to_dict("/etc/exim4/conf.d/main/")

def restore_time():
    for file in time_dict:
        os.utime(file, (time_dict[file][stat.ST_ATIME], time_dict[file][stat.ST_MTIME]))


save_time()

if len(sys.argv) > 1:
    os.system("cp /etc/exim4/conf.d/main/90_exim4-config_log_selector /var/tmp/exim4.conf.tmp")
    os.system('echo "MAIN_LOG_SELECTOR == -rejected_header" > /var/tmp/conf.tmp')
    os.system('cat /etc/exim4/conf.d/main/90_exim4-config_log_selector >> /var/tmp/conf.tmp')
    os.system("cp /var/tmp/conf.tmp /etc/exim4/conf.d/main/90_exim4-config_log_selector")
    os.system("update-exim4.conf")
    os.system("echo 'update-complete'")

else:
    os.system("cp /etc/exim4/conf.d/main/90_exim4-config_log_selector /var/tmp/exim4.conf.tmp")
    os.system('echo "MAIN_LOG_SELECTOR = -rejected_header" > /var/tmp/conf.tmp')
    os.system('cat /etc/exim4/conf.d/main/90_exim4-config_log_selector >> /var/tmp/conf.tmp')
    os.system("cp /var/tmp/conf.tmp /etc/exim4/conf.d/main/90_exim4-config_log_selector")
    os.system("update-exim4.conf")
    os.system("echo 'update-complete'")


restore_time()
